#include "SiriSSL.h"
#include <err.h>

#define ERR_errno       ERR_peek_error
#define ERR_errno_pop   ERR_get_error

char *
SSL_strerror(unsigned long SSL_errno)
{
        static char errbuf[ERR_MAX_LEN];
        return ERR_error_string(SSL_errno, errbuf);
}

unsigned long
SSL_errno()
{
        return ERR_errno();
}


MODULE = SiriSSL::ERR   PACKAGE = SiriSSL::ERR  PREFIX = ERR_
        
void
ERR_clear()

long
ERR_errno()

long
ERR_errno_pop()

SV *
ERR_verbose(...)
        PREINIT:
                char *cp;
                unsigned long SSL_errno;
        CODE:
                SSL_errno = items ? SvIV(ST(0)) : ERR_errno();

                SV_ALLOC(RETVAL, ERR_MAX_LEN);
                cp = ERR_error_string(SSL_errno, SvPVX(RETVAL));
                SvCUR_set(RETVAL, strlen(cp));
        OUTPUT:
                RETVAL

char *
ERR_reason(...)
        PREINIT:
                unsigned long SSL_errno;
        CODE:
                SSL_errno = items ? SvIV(ST(0)) : ERR_errno();
                RETVAL = ERR_reason_error_string(SSL_errno);
        OUTPUT:
                RETVAL


char *
ERR_func(...)
        PREINIT:
                unsigned long SSL_errno;
        CODE:
                SSL_errno = items ? SvIV(ST(0)) : ERR_errno();
                RETVAL = ERR_func_error_string(SSL_errno);
        OUTPUT:
                RETVAL


char *
ERR_lib(...)
        PREINIT:
                unsigned long SSL_errno;
        CODE:
                SSL_errno = items ? SvIV(ST(0)) : ERR_errno();
                RETVAL = ERR_lib_error_string(SSL_errno);
        OUTPUT:
                RETVAL


BOOT:
        SSL_load_error_strings();
