# SiriSSL Makefile
#
# Author: Liraz Siri <liraz@hushmail.com>
# Created: Wed May  5 19:05:45 IDT 1999

use Cwd;
use ExtUtils::MakeMaker;

my %prereq;              
sub CheckModule ($;$$) {
    my($module, $version, $package) = @_;
    $package ||= $module;
    $prereq{$module} = $version || 0;
    if ($version) {
        print "Checking for $package, $version or later ... ";
        eval "use $module $version";
        if ($@) {
            print("\nYou don't have installed the $package package,",
                  " version $version or later.\n");
            return 0;
        }
    } else {
        print "Checking for $package ... ";
        eval "use $module";
        if ($@) {
            print("\nYou don't have installed the $package package.\n");
            return 0;
        }
    }
    print "ok\n";
    return 1;
}

my $ok = 1;
$ok = 0 unless CheckModule("Devel::WeakRef");
if (!$ok) {
    print <<"MESSAGE";

Missing modules are available from any CPAN mirror, for example
  ftp://ftp.funet.fi/pub/languages/perl/CPAN/modules/by-module

MESSAGE
}

@OBJS = (grep(s/\.xs$/.o/, <*.xs>), grep(s/([a-z_]+)\.c$/$1.o/, <*.c>));

$SSLPATH = '/usr/local/ssl';
WriteMakefile('NAME'         => 'SiriSSL',
              'VERSION_FROM' => 'SiriSSL.pm',
              'LIBS'         => ["-L$SSLPATH/lib -lssl -lcrypto"],
              'INC'          => "-I$SSLPATH/include",
              'XSOPT'        => '-noversioncheck',
              'PREREQ_PM'    => \%prereq,
              'OBJECT'       => join(' ', @OBJS));

