#include "SiriSSL.h"
#include <rand.h>

MODULE = SiriSSL::RAND          PACKAGE = SiriSSL::RAND         PREFIX = RAND_

int
RAND_load_noise(bytes, ...)
                int     bytes
        PREINIT:
                char    buf[256], *filename;
                SV *    arg;                
        CODE:
                if(items > 1) {
                        arg = ST(1);
                        if(!SvPOK(arg))
                               croak("RAND_load_noise: "
                                     "filename arg must be a string");
                        filename = SvPVX(arg);
                } else {
                        if(!RAND_file_name(buf, sizeof(buf)))
                                croak("RAND_load_noise: "
                                      "can't load noise, undefined noisefile");
                        filename = buf;
                }
                RETVAL = RAND_load_file(filename, bytes);
        OUTPUT:
                RETVAL

int
RAND_save_noise(...)
        PREINIT:
                SV *    arg;
                char    buf[256], *filename;
        CODE:
                if(items > 0) {
                        arg = ST(0);
                        if(!SvPOK(arg))
                                croak("RAND_save_noise: "
                                      "filename arg must be a string!");
                        filename = SvPVX(arg);
                } else {
                        if(!RAND_file_name(buf, sizeof(buf)))
                                croak("RAND_load_noise: "
                                      "can't load noise, undefined noisefile");
                        filename = buf;
                }
                RETVAL = RAND_write_file(filename);
        OUTPUT:
                RETVAL

void
RAND_add_noise(seed)
                SV *    seed
        PREINIT:
                char *  cp;
                int     len;
        CODE:
                if(SvPOK(seed))
                        cp = SvPV(seed, len);
                else
                        cp = SvPV_force(sv_2mortal(newSVsv(seed)), len);
                RAND_seed(cp, len);                
        
SV *
RAND_get_noise(bytes)
                int     bytes
        CODE:
                SV_ALLOC(RETVAL, bytes);
                RAND_bytes(SvPVX(RETVAL), bytes);
                SvCUR_set(RETVAL, bytes);
        OUTPUT:
                RETVAL

char *
RAND_default_noisefile()
        PREINIT:
                char filename[256];
        CODE:
                RETVAL = RAND_file_name(filename, sizeof(filename));
        OUTPUT:
                RETVAL

void
RAND_cleanup()
