/*
 SiriSSL.xs

 Author: Liraz Siri <liraz@hushmail.com>

 Copyrights (c) 1999 Liraz Siri <liraz@hushmail.com>, Ariel, Israel
                All rights reserved.

 Created: Thu Jun 17 18:54:02 IDT 1999

 Sketchy perl support for OpenSSL.
*/
#include "SiriSSL.h"

int
SSL_CONSTANT(name)
char *name;
{
        errno = 0;
        switch(*name) {

	case 'C':
                if(strEQ(name, "CB_ALERT"))
                        return SSL_CB_ALERT;

                if(strEQ(name, "CB_EXIT"))
                        return SSL_CB_EXIT;

                if(strEQ(name, "CB_LOOP"))
                        return SSL_CB_LOOP;

                if(strEQ(name, "CB_READ"))
                        return SSL_CB_READ;

                if(strEQ(name, "CB_WRITE"))
                        return SSL_CB_WRITE;
		break;

	case 'E':
                if(strEQ(name, "ERROR_NONE"))
                        return SSL_ERROR_NONE;
                if(strEQ(name, "ERROR_SSL"))
                        return SSL_ERROR_SSL;
                if(strEQ(name, "ERROR_SYSCALL"))
                        return SSL_ERROR_SYSCALL;
                if(strEQ(name, "ERROR_WANT_CONNECT"))
                        return SSL_ERROR_WANT_CONNECT;
                if(strEQ(name, "ERROR_WANT_READ"))
                        return SSL_ERROR_WANT_READ;
                if(strEQ(name, "ERROR_WANT_WRITE"))
                        return SSL_ERROR_WANT_WRITE;
                if(strEQ(name, "ERROR_WANT_X509_LOOKUP"))
                        return SSL_ERROR_WANT_X509_LOOKUP;
                if(strEQ(name, "ERROR_ZERO_RETURN"))
                        return SSL_ERROR_ZERO_RETURN;
		break;

	case 'O':
                if(strEQ(name, "OP_ALL"))
                        return SSL_OP_ALL;
                if(strEQ(name, "OP_NETSCAPE_DEMO_CIPHER_CHANGE_BUG"))
                        return SSL_OP_NETSCAPE_DEMO_CIPHER_CHANGE_BUG;
                if(strEQ(name, "OP_NON_EXPORT_FIRST"))
                        return SSL_OP_NON_EXPORT_FIRST;
                if(strEQ(name, "OP_NO_SSLv2"))
                        return SSL_OP_NO_SSLv2;
                if(strEQ(name, "OP_NO_SSLv3"))
                        return SSL_OP_NO_SSLv3;
                if(strEQ(name, "OP_NO_TLSv1"))
                        return SSL_OP_NO_TLSv1;
		break;

	case 'S':
                if(strEQ(name, "SESS_CACHE_BOTH"))
                        return SSL_SESS_CACHE_BOTH;
                if(strEQ(name, "SESS_CACHE_CLIENT"))
                        return SSL_SESS_CACHE_CLIENT;
                if(strEQ(name, "SESS_CACHE_NO_AUTO_CLEAR"))
                        return SSL_SESS_CACHE_NO_AUTO_CLEAR;
                if(strEQ(name, "SESS_CACHE_NO_INTERNAL_LOOKUP"))
                        return SSL_SESS_CACHE_NO_INTERNAL_LOOKUP;
                if(strEQ(name, "SESS_CACHE_OFF"))
                        return SSL_SESS_CACHE_OFF;
                if(strEQ(name, "SESS_CACHE_SERVER"))
                        return SSL_SESS_CACHE_SERVER;
                if(strEQ(name, "ST_ACCEPT"))
                        return SSL_ST_ACCEPT;
                if(strEQ(name, "ST_CONNECT"))
                        return SSL_ST_CONNECT;
                if(strEQ(name, "ST_MASK"))
                        return SSL_ST_MASK;
		break;

	case 'V':
                if(strEQ(name, "VERIFY_CLIENT_ONCE"))
                        return SSL_VERIFY_CLIENT_ONCE;
                if(strEQ(name, "VERIFY_FAIL_IF_NO_PEER_CERT"))
                        return SSL_VERIFY_FAIL_IF_NO_PEER_CERT;
                if(strEQ(name, "VERIFY_NONE"))
                        return SSL_VERIFY_NONE;
                if(strEQ(name, "VERIFY_PEER"))
                        return SSL_VERIFY_PEER;

                break;

        case 'M':
                if(strEQ(name, "METHOD_SSLv2"))
                        return SSL_METHOD_SSLv2;
                if(strEQ(name, "METHOD_SSLv23"))
                        return SSL_METHOD_SSLv23;
                if(strEQ(name, "METHOD_SSLv3"))
                        return SSL_METHOD_SSLv3;
                break;

        case 'F':
                if(strEQ(name, "FILETYPE_PEM"))
                        return SSL_FILETYPE_PEM;
                if(strEQ(name, "FILETYPE_ASN1"))
                        return SSL_FILETYPE_ASN1;
                break;
        }
        errno = EINVAL;
        return 0;
}


static int
constant(name)
        char *name;
{
        errno = 0;
        switch(*name) {
                case 'S':
                        MATCH_CONSTANT(name, SSL_);
                        break;
                case 'X':
                        MATCH_CONSTANT(name, X509_V_);
                        break;
        }

        errno = EINVAL;
        return 0;
}

static void     callXS (void (*subaddr)(CV* cv), CV *cv, SV **mark) 
{
	int items;
	dSP;
	PUSHMARK (mark);
	(*subaddr)(cv);

	PUTBACK;  /* Forget the return values */
}

int
boot_ssl()
{
        SSLeay_add_all_algorithms();
}

MODULE = SiriSSL        PACKAGE = SiriSSL

int
constant(name)
        char *          name

BOOT:
{
        BOOT_DEF(SSL);
        BOOT_DEF(SSL_CTX);
        BOOT_DEF(SSL_CIPHER);
        BOOT_DEF(X509);
        BOOT_DEF(X509_NAME);
        BOOT_DEF(X509_REQ);
        BOOT_DEF(X509_STORE_CTX);
        BOOT_DEF(EVP_PKEY);
        BOOT_DEF(ERR);
        BOOT_DEF(PEM);
        BOOT_DEF(RAND);

        BOOT_CALL(SSL);
        BOOT_CALL(SSL_CTX);
        BOOT_CALL(SSL_CIPHER);
        BOOT_CALL(X509);
        BOOT_CALL(X509_NAME);
        BOOT_CALL(X509_REQ);
        BOOT_CALL(X509_STORE_CTX);
        BOOT_CALL(ERR);
        BOOT_CALL(PEM);
        BOOT_CALL(EVP_PKEY);
        BOOT_CALL(RAND);

        boot_ssl();
}
