#include "SiriSSL.h"

#define X509_REQ_get_name       X509_REQ_get_subject_name

MODULE = SiriSSL::X509_REQ  PACKAGE = SiriSSL::X509_REQ  PREFIX = SiriSSL::X509_REQ


X509_REQ *
X509_REQ_new(class)
                SV *    class
        CODE:
                RETVAL = X509_REQ_new();
        OUTPUT:
                RETVAL

int
X509_REQ_verify(req)
                X509_REQ        *req
        PREINIT:
                EVP_PKEY        *pkey;
        CODE:
                pkey = X509_REQ_get_pubkey(req);
                RETVAL = X509_REQ_verify(req, pkey);
                EVP_PKEY_free(pkey);
        OUTPUT:
                RETVAL

int
X509_REQ_get_version(req)
        X509_REQ *req

EVP_PKEY *
X509_REQ_get_pubkey(req)
        X509_REQ *req

X509_NAME *
X509_REQ_get_name(req)
        X509_REQ *req

int
X509_REQ_set_version(req, version)
        X509_REQ *      req
        long            version

int
X509_REQ_set_subject_name(req, name)
        X509_REQ *      req
        X509_NAME *     name

int
X509_REQ_set_pubkey(req, pkey)
        X509_REQ *      req
        EVP_PKEY *      pkey
