#include "SiriSSL.h"

#define X509_STORE_CTX_error            X509_STORE_CTX_get_error
#define X509_STORE_CTX_error_cert       X509_STORE_CTX_get_current_cert
#define X509_STORE_CTX_error_depth      X509_STORE_CTX_get_error_depth

#define X509_STORE_CTX_cert(ctx)                ((ctx)->cert)
#define X509_STORE_CTX_last_untrusted(ctx)      ((ctx)->last_untrusted)

#define X509_error_str          X509_verify_cert_error_string

#define X509_STORE_CTX_error_str(ctx)   \
        X509_error_str(X509_STORE_CTX_error(ctx))

#define X509_STORE_CTX_SSL_IDX \
        SSL_get_ex_data_X509_STORE_CTX_idx()

#define X509_STORE_CTX_ssl(ctx) \
        (SSL *)X509_STORE_CTX_get_ex_data(ctx, X509_STORE_CTX_SSL_IDX)


MODULE = SiriSSL::X509_STORE_CTX  PACKAGE = SiriSSL::X509_STORE_CTX   PREFIX = X509_STORE_CTX_

SSL     *
X509_STORE_CTX_ssl(ctx)
                X509_STORE_CTX *ctx
        CODE:
                RETVAL = X509_STORE_CTX_ssl(ctx);
                if(RETVAL) REF_INC(RETVAL, SSL);
        OUTPUT:
                RETVAL

X509    *
X509_STORE_CTX_cert(ctx)
                X509_STORE_CTX *ctx
        CODE:
                RETVAL = X509_STORE_CTX_cert(ctx);
                REF_INC(RETVAL, X509);  /* fix reference count */
        OUTPUT:
                RETVAL


int
X509_STORE_CTX_last_untrusted(ctx)
                X509_STORE_CTX *ctx


void
X509_STORE_CTX_cert_chain(ctx)
                X509_STORE_CTX *ctx
        PREINIT:
                STACK * chain;
                int     i;
        PPCODE:
                chain = X509_STORE_CTX_get_chain(ctx);
                for(i = 0; i < sk_num(chain); i++) {
                        X509    *cert = (X509 *)sk_value(chain, i);

                        REF_INC(cert, X509);
                        XPUSH_OBJ(cert, SiriSSL::X509);
                }


int
X509_STORE_CTX_error(ctx)
        X509_STORE_CTX *ctx


char *
X509_STORE_CTX_error_str(ctx)
        X509_STORE_CTX *ctx


X509    *
X509_STORE_CTX_error_cert(ctx)
        X509_STORE_CTX *ctx
        CODE:
                RETVAL = X509_STORE_CTX_error_cert(ctx);
                REF_INC(RETVAL, X509);  /* fix reference count */
        OUTPUT:
                RETVAL


int
X509_STORE_CTX_error_depth(ctx)
        X509_STORE_CTX *ctx
