#!/usr/bin/perl
use blib;
use SiriSSL qw(:all);
use IO::Socket;
use strict 'subs';

$CA_PATH = "/var/tmp/pki";

$addr = shift || 'localhost';
($addr, $port) = split(/:/, $addr, 2);
$port ||= 4433;

$sock = IO::Socket::INET->new("$addr:$port")
    or die "can't connect: $!";

$ssl_ctx = SiriSSL::SSL_CTX->new();
use_cert($ssl_ctx, "edna");

$ssl_ctx->set_verify(SSL_VERIFY_PEER, \&verify_cb);
$ssl_ctx->trusted_certs("$CA_PATH/family-root.pk");

$ssl = SiriSSL::SSL->new($ssl_ctx, 0, $sock)
    or die sprintf("ssl connection failed: %s", SiriSSL::ERR::reason());

print "connected ($addr:$port)...\n";
if(!fork) {
    $ssl->print while(<STDIN>);
    print "connection closed by local host\n";
} else {
    print $msg while($ssl->read($msg) > 0);
    print "connection closed by foriegn host\n";
}

sub verify_cb {
    my ($ok, $ctx) = @_;

    print "verify_cb, ok = $ok!\n";
#      my $ssl = $ctx->ssl;
    
#      my $error = $ctx->error;
#      my $error_str = $ctx->error_str;
#      my $error_cert = $ctx->error_cert;
#      my $error_depth = $ctx->error_depth;

#      my $cert = $ctx->cert;
#      my @certs = $ctx->cert_chain;
#      my $index = $ctx->last_untrusted;
    
    1;
};

sub use_cert {
    my ($ssl_ctx, $cert) = @_;

    $ssl_ctx->use_PrivateKey_file("$CA_PATH/$cert.sk")
        or die "$cert.sk: can't load private key!";
    $ssl_ctx->use_certificate_file("$CA_PATH/$cert.pk")
        or die "$cert.pk: can't load certificate!";
    print "certificate matches key\n" if $ssl_ctx->check_private_key();
}

1;

