#!/usr/bin/perl

print<<EOF;
static double
constant(name)
char *name;
{
        errno = 0;
        switch(*name) {
EOF

        @macros = sort(grep(s/^\s*#define\s+X509_V_ERR_(\S+).*/$1/s, <>));
        my $head;
        for $macro (@macros) {
                my $macro_head = substr($macro, 0, 1);
                if($head ne $macro_head) {
                        print "\t\tbreak;\n" if $head;
                        print "\n\tcase '$macro_head':\n";
                        $head = $macro_head;
                }
                print<<EOF;
                if(strEQ(name, "$macro"))
                        return X509_V_ERR_$macro;
EOF
        }
        print "\t\tbreak;\n" if $head;

print<<EOF;
        }
        errno = EINVAL;
        return 0;
}
EOF

