#!/usr/bin/perl
use blib;
use SiriSSL qw(:all);
use IO::Socket;

($addr, $url) = @ARGV;
($addr, $port) = split(/:/, $addr, 2);
$port ||= 443;

untaint(@ARGV);

$sock = IO::Socket::INET->new("$addr:$port")
    or die "can't connect: $!";

$ssl_ctx = SiriSSL::SSL_CTX->new();
$ssl_ctx->set_verify(SSL_VERIFY_PEER, \&verify_cb);
$ssl_ctx->load_verify_locations("/var/tmp/pki/family-root.pk", undef);
$ssl = SiriSSL::SSL->new($ssl_ctx, 0, $sock)
    or die sprintf("ssl connection failed: %s", SiriSSL::ERR::reason());

$ssl->write("GET $url HTTP/1.0\n\n");
@lines = $ssl->getlines();
print "$_: $lines[$_]" foreach (0 .. $#lines);

my $i = 0;

sub verify_cb {
    my ($ok, $ctx) = @_;

    print "verify_cb, ok = $ok!\n";
    my $ssl = $ctx->ssl;
    
    my $error = $ctx->error;
    my $error_str = $ctx->error_str;
    my $error_cert = $ctx->error_cert;
    my $error_depth = $ctx->error_depth;

    my $cert = $ctx->cert;
    my @certs = $ctx->cert_chain;
    my $index = $ctx->last_untrusted;
    
    1;
};

sub hook() { @_ };

sub is_tainted {
    return ! eval {
        join('',@_), kill 0;
        1;
    };
}

sub untaint {
    foreach (@_) {
        /(.*)/; $_ = $1;
    }
}

1;

