#!/usr/bin/perl
use blib;
use SiriSSL;
use Time::localtime;

# example certificate.
$encoded =<<EOF;
-----BEGIN CERTIFICATE-----
MIICWTCCAgOgAwIBAgIBADANBgkqhkiG9w0BAQQFADBOMQswCQYDVQQGEwJJTDEP
MA0GA1UECBMGSXNyYWVsMQ4wDAYDVQQHEwVBcmllbDEPMA0GA1UECxMGRmFtaWx5
MQ0wCwYDVQQDEwRTaXJpMB4XDTk5MDYxMzIyMzQwNloXDTAwMDYxMjIyMzQwNlow
TjELMAkGA1UEBhMCSUwxDzANBgNVBAgTBklzcmFlbDEOMAwGA1UEBxMFQXJpZWwx
DzANBgNVBAsTBkZhbWlseTENMAsGA1UEAxMEU2lyaTBcMA0GCSqGSIb3DQEBAQUA
A0sAMEgCQQC9yTJ/T1xTmgLWFu7tb27Dmx5R8UY2M4Lubtk9Q4IpzA0FJPgfSiFs
DI829l5fhGUIuYmSjWwSys2OHN67XqlDAgMBAAGjgcswgcgwDAYDVR0TBAUwAwEB
/zAdBgNVHQ4EFgQUc5vwpslFmcWH0Rpo2QPOVdV/k1kwdgYDVR0jBG8wbYAUc5vw
pslFmcWH0Rpo2QPOVdV/k1mhUqRQME4xCzAJBgNVBAYTAklMMQ8wDQYDVQQIEwZJ
c3JhZWwxDjAMBgNVBAcTBUFyaWVsMQ8wDQYDVQQLEwZGYW1pbHkxDTALBgNVBAMT
BFNpcmmCAQAwCwYDVR0PBAQDAgEGMAkGA1UdEQQCMAAwCQYDVR0SBAIwADANBgkq
hkiG9w0BAQQFAANBAK2i2dtNkp9Dh8ovVpUAoD1h8K0J2nQetg3essdRtjdoRO3X
R4pZjz6eJoDdYo2DkwH7m0UGHGkHyli8FPlhEJA=
-----END CERTIFICATE-----
EOF

sub rebuild {
    my $cert = shift;
    return SiriSSL::PEM::decode_cert(SiriSSL::PEM::encode_cert($cert));
}

$cert = SiriSSL::PEM::decode_cert($encoded);
$cert->name->name('siri');

1;
