#!/usr/bin/perl
use blib;
use SiriSSL ':all';
use IO::Socket;

$CA_PATH = "/var/tmp/pki";

$port = shift || 4433;
$server = _listen($port);

$ssl_ctx = SiriSSL::SSL_CTX->new();
use_cert($ssl_ctx, "moshe");

$ssl_ctx->set_verify(SSL_VERIFY_PEER,
                     \&verify_cb);
$ssl_ctx->trusted_certs("$CA_PATH/family-root.pk");

while($client = $server->accept())
{
    warn(sprintf "ssl connection failed: %s", SiriSSL::ERR::reason()), next
        unless($ssl = SiriSSL::SSL->new($ssl_ctx, 1, $client));

    while($ssl->read($msg)) {
        $ssl->write("bounced: $msg");
    }
}

sub _listen {
    my $port = shift;
    my $sock = IO::Socket::INET->new
        (Listen => 1,
         Reuse => 1,
         LocalPort => $port)
            or die "can't listen: $!";
    return $sock;
}

sub verify_cb {
    my ($ok, $ctx) = @_;

    print "verify_cb, ok = $ok!\n";
#      my $ssl = $ctx->ssl;
    
#      my $error = $ctx->error;
#      my $error_str = $ctx->error_str;
#      my $error_cert = $ctx->error_cert;
#      my $error_depth = $ctx->error_depth;

#      my $cert = $ctx->cert;
#      my @certs = $ctx->cert_chain;
#      my $index = $ctx->last_untrusted;
    
    1;
};

sub use_cert {
    my ($ssl_ctx, $cert) = @_;

    $ssl_ctx->use_PrivateKey_file("$CA_PATH/$cert.sk")
        or die "$cert.sk: can't load private key!";
    $ssl_ctx->use_certificate_file("$CA_PATH/$cert.pk")
        or die "$cert.pk: can't load certificate!";
    print "certificate matches key\n" if $ssl_ctx->check_private_key();
}

1;
