#!/usr/bin/perl
use blib;
use PerlSSL ':all';
use IO::Socket;

$port = shift || 4433;
$server = _listen($port);

$ssl_ctx = PerlSSL::SSL::CTX->new();
$cert = "/var/tmp/pki/moshe";

$ssl_ctx->use_PrivateKey_file("$cert.sk")
    or die "$cert.sk: can't load private key!";

$ssl_ctx->use_certificate_file("$cert.pk")
    or die "$cert.pk: can't load certificate!";

print "certificate matches key\n" if $ssl_ctx->check_private_key();
while($client = $server->accept())
{
    $ssl = PerlSSL::SSL->new($ssl_ctx, 1, $client);
    while($ssl->read($msg, 1024)) {
        $ssl->write($msg);
    }
}

sub _listen {
    my $port = shift;
    my $sock = IO::Socket::INET->new
        (Listen => 1,
         Reuse => 1,
         LocalPort => $port)
            or die "can't listen: $!";
    return $sock;
}


1;
